$regfile = "m32def.dat"
$crystal = 16000000
$baud = 19200
$hwstack = 64
$swstack = 64
$framesize = 100







Declare Sub Getline(s As String)
Declare Sub Flushbuf()

Config Serialin = Buffered , Size = 60
Config 1wire = Portd.3                                      '  18b20


Dim Porog_eep As Eram Byte
Dim Porog As Byte                                           '  
Porog = Porog_eep                                           '     

If Porog = 0 Then
 Porog = 20
End If

Dim Temp_str As String * 5
Dim Porog_str As String * 3                                 '  

Config Porta.0 = Input
Dim Last As Bit


Config Portd.2 = Output
Portd.2 = 1
Dim Ss As Bit

Enable Interrupts


' 
'======================================================================================
Config Porta.2 = Output
Led Alias Porta.2
Led = 0


'    
'===========================================================================================
Config Portd.4 = Input
Vkl Alias Pind.4


'   
'======================================================================================
Config Portd.5 = Output
Powerkey Alias Portd.5
Powerkey = 0


'   
'===========================================================================================
Config Portd.6 = Output
Outpin Alias Portd.6
Outpin = 0


'    
'===========================================================================================
Config Portd.7 = Input
Pir Alias Pind.7


'2 ,     40 
Config Portd.2 = Output
Outpin2 Alias Portd.2
Outpin2 = 0






'     
Config Int2 = Falling                                       '   
On Int2 Ok                                                  '   

Enable Interrupts
'Enable Int0



'--------------------------------------------------------------------------------------
Dim Number As String * 11                                   ' 
Dim Temp As String * 10
Dim Temp1 As String * 10
Dim Temp2 As String * 10
Dim Rs As Byte
Dim A As Byte
Dim S As String * 50
Dim B As Byte
Dim R As Byte
Dim Z As String * 15
Dim Sms_num As String * 2                                   '  
Dim Stmp As String * 1
Dim Sms As String * 120
Dim Otvet As String * 160                                   ',    
Dim Sk As String * 66
Dim Tmr As Byte
Dim Sms_val As Byte

Dim F As Byte
Dim Error As Byte                                           '       
Dim U As Byte                                               '  ,        getline
Dim Loadpin As Bit                                          '    
Dim Pirsend As Byte                                         '        
Dim Loadpinstr As String * 3
Dim Pirstr As String * 1
Dim Pirsendstr As String * 3

Dim Pirsendeep As Eram Byte                                 '     

Pirsend = Pirsendeep


Dim Autootveteep As Eram Byte                               '      
Dim Autootvet As Byte

Autootvet = Autootveteep


Dim T As Byte                                               '
Dim Sign As String * 5                                      ' 
Dim Byte0 As Byte
Dim Byte1 As Byte
Dim T1 As Byte
Dim T2 As Byte
Dim Tstr As String * 4

Dim Numb As Byte
Dim Connect As String * 6                                   ' 
Dim Connectvar As Byte                                      '    
Dim Operator As String * 20
Dim Date_str As String * 20
Dim Time_str As String * 20

Dim Zadergka As Byte                                        '   
Dim Zadergka_str As String * 14

'---------------------------------------------------------------------------------------
'Const Phonenumber = "+7908390xxxx"                          '       (  )

'    
Dim Phonenumbereeprom As Eram String * 12

Dim Phonenumber As String * 12

'     
Phonenumber = Phonenumbereeprom



Config Porta.1 = Output                                     '   

Pirsms Alias Porta.1
Pirsms = 0



Config Portc.1 = Output
Portc.1 = 0
Config Portc.6 = Output
Portc.6 = 1



' I/O  3310
'========================================================================================
'========================================================================================
Config Porta.5 = Output                                     'D/C (pin 4)
D3310dc Alias Porta.5

Config Porta.6 = Output                                     'SCE (pin 5)
D3310ce Alias Porta.6

Config Porta.7 = Output                                     'Reset (pin 8)
D3310re Alias Porta.7

' SPI   . SCLK (pin 2) - PORTA.3; SDA (pin 3) - PORTA.4; Din  
Config Spi = Soft , Din = Porta.1 , Dout = Porta.4 , Ss = None , Clock = Porta.3



Dim Vers As String * 14
Vers = "Rev.130327.d"                                       ' 

' Spi
Spiinit

$include "3310init.bas"

' SPI
Call D3310reset
Call D3310init
Call D3310clear



'

$include "sim900.bas"                                       '   



' 
'********************************************************
Led = 1
Print "AT+CMGF=1"                                           '   
Waitms 50
Print "AT+CLIP=1"                                           '   
Wait 3
Led = 0
Flushbuf


If Autootvet = 1 Then                                       '   1   
 Print "ATS0=2"                                             '  
 Waitms 800
 Flushbuf
End If


Call D3310clear




'###########################################################################
' 
'###########################################################################

Do

Led = 1
Gosub Checkmodule                                           '  
Gosub Readsms                                               '     
Gosub Readfirstsms                                          '  ,  
Gosub Checksms                                              '   
Gosub Operator                                              ' 
Gosub Connect                                               ' 
Gosub Time_date                                             '  
Gosub 18b20                                                 '  
Gosub Sensor
Led = 0

Enable Int2
Wait 10
If Pina.0 = 0 Then                                          '  PinA.0 = 0  
  If Last = 1 Then                                          '    1
  Otvet = "220 Off!"
  Gosub Sendsms
  Flushbuf
  Last = 0
  End If
End If

If Pina.0 = 1 Then                                          '  PinA.0 =1  
  If Last = 0 Then                                          '    0
  Otvet = "220 On!"
  Gosub Sendsms
  Flushbuf
  Last = 1
  End If
End If




Disable Int2

Loop

End

$include "3310end.bas"
$include "3310bmp1.bas"
'$include "3310bmp2.bas"






'    
'=============================================================================
Sub Getline(s As String)
   S = ""
   Do

      B = Inkey()                                           '      ASCII
      Select Case B
          Case 0                                            '    
          Case 13                                           '  (Enter),     
          Case 10 : If S <> "" Then Exit Do                 ' ,    
          Case Else : If B > 31 Then S = S + Chr(b)         '     32   ,    
      End Select




   Loop
End Sub

' 
'=============================================================================
Sub Flushbuf()
 Waitms 100
 Do
 B = Inkey()                                                '   
 Loop Until B = 0
End Sub





'   
'=============================================================================
Readsms:
R = Ischarwaiting()                                         '    
  If R = 1 Then
     Getline Sk                                             '      
     Z = Left(sk , 4)                                       '  4 

        If Z = "+CMT" Then                                  ' +,      
           Sms_num = Right(sk , 2)                          '    
           Stmp = Left(sms_num , 1)                         '   
               If Stmp = "," Then
                 Sms_num = Right(sk , 1)                    '  ","     .      
               End If
           Wait 1
           Number = ""
           Print "AT+CMGR=" ;                               '   
           Print Sms_num                                    '      
           Waitms 10
           Getline Sk
           Waitms 10
           Getline Sk
           Number = Mid(sk , 22 , 12)                       '     
           Sms = Sk                                         '   
           Waitms 10
           Getline Sk                                       ',    
           Sms = Sk
           Sms = Left(sms , 14)                             '   14    ( -   )

            Do
              Led = 0
              Waitms 100
              Led = 1
              Waitms 50
              Incr F
            Loop Until F = 10                               '   
            F = 0

           Call D3310position(0 , 2)                        '          
           Call D3310print( "              ")
           Call D3310position(0 , 2)
           Call D3310print(number)

           Call D3310position(0 , 3)
           Call D3310print( "              ")
           Call D3310position(0 , 3)
           Call D3310print(sms)

           Print "AT+CMGDA=" ; Chr(34) ; "DEL ALL" ; Chr(34)       ' 

        End If

      Waitms 100
      Flushbuf                                              ' 

  End If

Return






'    
'======================================================================================================
Checksms:

If Sms = "0" Then                                           '    ,   
 Outpin = 0
 Outpin2 = 0
 Loadpin = 0
 Loadpinstr = "Off"
 Sms = ""
 Call D3310position(0 , 2)
 Call D3310print( "     ")
 Call D3310position(0 , 3)
 Call D3310print( "     ")

End If

If Sms = "1" Then                                           ' ,   
   Outpin = 1                                               ' 
   Call D3310position(0 , 3)
   Call D3310print( "      ")


   Zadergka = 40

   Do                                                       '  40 
    Zadergka_str = Str(zadergka)
    Zadergka_str = " " + " " + Zadergka_str + "c"

    Call D3310position(0 , 2)
    Call D3310print( "              ")
    Call D3310position(0 , 2)
    Call D3310print(zadergka_str)
    Wait 1
    Decr Zadergka

   Loop Until Zadergka = 0

   Outpin2 = 1                                              ' 
   Loadpin = 1
   Loadpinstr = "ON"
   Sms = ""
   Call D3310position(0 , 2)
   Call D3310print( "      ")

Flushbuf
End If



If Sms = "2" Then                                           ' ,   
 Gosub Atd
 Sms = ""
 Number = ""

End If

If Sms = "3" Then                                           ' ,       
 Gosub Balanse
 Sms = ""
 Number = ""

End If

If Sms = "4" Then                                           '    4,     
   Gosub 18b20
   Otvet = Sign + Tstr
   Gosub Sendsms
   Flushbuf
End If

If Sms = "5" Then
  Pirsend = 0                                               '      

  Pirsendeep = Pirsend                                      '   

  Sms = ""
End If

If Sms = "6" Then
  Pirsend = 1                                               '     
  Pirsendeep = Pirsend
  Sms = ""
End If



If Sms = "7" Then
  Print "ATS0=0"                                            '      
  Sms = ""
End If

If Sms = "8" Then
  Print "ATS0=2"                                            '    
  Sms = ""
End If




If Sms = "Firstnumber" Then                                 '    
  Phonenumber = Number                                      '          
  Phonenumbereeprom = Phonenumber                           '    
  Otvet = "Number: " + Phonenumber + " OK"
  Gosub Sendsms
  Sms = ""

End If

If Sms = "?" Then                                           '         
  Porog_str = Str(porog)                                    '        
  Otvet = "SIM900D" + Chr(10) + "Temp:" + Sign + Tstr + Chr(10) + "Porog" + Porog_str + Chr(10) + "Load:" + Loadpinstr + Chr(10) + "Sensor:" + Pirstr + Chr(10) + "Send SMS from sensors:" + Pirsendstr
  Gosub Sendsms
  Sms = ""
End If

If Sms <> "" Then
 Temp_str = Sms
 Sms = Left(sms , 1)
  If Sms = "t" Or Sms = "T" Then
   Temp_str = Right(temp_str , 2)
   Porog = Val(temp_str)
   Porog_eep = Porog                                        '    
   Sms = ""
  End If
End If

Return







'  
'=============================================================================
Sendsms:
Print "AT+CMGS=" ; Chr(34) ; Phonenumber ; Chr(34)
Waitms 200
Print Otvet ; Chr(26)

Print Chr(26);
Wait 1
Print Chr(13)
' 

    Do
    Led = 0
    Waitms 100
    Led = 1
    Waitms 50
    Incr F
    Loop Until F = 10
    F = 0

Return



'   
'********************************************************
18b20:
1wreset
If Err = 1 Then
 T = 255
 Sign = "error"
 Call D3310position(0 , 1)
 Call D3310print(sign)
 Return
Else
1wwrite &HCC
1wwrite &H44
Waitms 750
1wreset
1wwrite &HCC
1wwrite &HBE
 Byte0 = 1wread()
 Byte1 = 1wread()
If Byte1 > 248 Then
 Byte0 = &HFF - Byte0
 Byte1 = &HFF - Byte1
 Sign = "-"
Else
 Sign = "+"
End If
 T1 = Byte0 / 16
 T2 = Byte1 * 16
 T = T1 + T2

If Sign = "-" Then
  T = T1 + 1
End If
If Sign = "+" And T = 0 Then
  Sign = " "
End If
End If


If Loadpin = 1 Then                                         '


 '   
   If T >= Porog Then
  ' 
     Portd.2 = 0
     Ss = 1                                                 '  

   Call D3310position(0 , 2)
   Call D3310print( "     ")

 End If

 If Ss = 1 And T < Porog Then
  Portd.2 = 1                                               ' 
  Ss = 0
  Call D3310position(0 , 2)
  Call D3310print( "      ")

 End If

End If







Tstr = Str(t)
Tstr = Format(tstr , 00)

If T = 255 Then
Tstr = ""
End If

Call D3310position(0 , 1)
Call D3310print( "              ")                          '  

Call D3310position(0 , 1)
Call D3310print(sign)
Call D3310position(1 , 1)
Call D3310print(tstr)

If T = 255 Then
Call D3310position(3 , 1)
Call D3310print( "  ")
Else
Call D3310position(3 , 1)
Call D3310print( "C")
End If


Porog_str = Str(porog)
Porog_str = Format(porog_str , 00)
Call D3310position(6 , 1)
Call D3310print( "/")

Call D3310position(8 , 1)
Call D3310print( "+")
Call D3310position(9 , 1)
Call D3310print(porog_str)
Call D3310position(11 , 1)
Call D3310print( "C")


Return



'  
'=====================================================================
Operator:

Print "AT+COPS?"                                            '    

   Waitms 500
   Getline Sk
   Waitms 100
   Getline Sk
   Operator = Sk
   Operator = Mid(operator , 12 , 9)

   Call D3310position(0 , 0)
   Call D3310print( "           ")

   Call D3310position(0 , 0)
   Call D3310print(operator)

   Flushbuf

Return



'   
'=====================================================================
Connect:

 Call D3310position(11 , 0)
 Call D3310print( "^")                                      '  

Print "AT+CSQ"                                              ' 

  Waitms 300
  Getline Sk
  Waitms 100
   Getline Sk
   Connect = Sk

  Connect = Mid(connect , 7 , 2)
  Connectvar = Val(connect)

    Call D3310position(12 , 0)
    Call D3310print( "  ")

    If Connectvar > 0 And Connectvar < 4 Then               '  
      Call D3310position(12 , 0)
      Call D3310print( "> ")
    Elseif Connectvar > 4 And Connectvar < 9 Then
      Call D3310position(12 , 0)
      Call D3310print( "< ")
    Elseif Connectvar > 9 And Connectvar < 15 Then
      Call D3310position(12 , 0)
      Call D3310print( "<@")
    Elseif Connectvar > 15 And Connectvar < 32 Then
      Call D3310position(12 , 0)
      Call D3310print( "<&")

    Elseif Connectvar = 0 Or Connectvar = 99 Then
      Call D3310position(12 , 0)
      Call D3310print( "$")

    End If


   Flushbuf


Return






' 
'================================================================================
Time_date:

Print "AT+CCLK?"

Waitms 400
Getline Sk

Waitms 400
Getline Sk


Time_str = Mid(sk , 18 , 5)

Call D3310position(0 , 5)
Call D3310print( "              ")


Call D3310position(0 , 5)                                   '   
Call D3310print(time_str)

Flushbuf

Return





'    
'========================================================================================
Atd:

Print "ATD" ; Phonenumber ; ";"

Waitms 100

Flushbuf

Return


' 
'=================================================================================
Balanse:

  Print "ATD#100#"
  Wait 1
  Getline Sk
  Getline Sk
  Getline Sk
  Otvet = Sk
  Gosub Sendsms

Flushbuf

Return


'  ,     
Checkmodule:



  If Loadpin = 0 Then
   Loadpinstr = "Off"
  Else
   Loadpinstr = "ON"
  End If



If Vkl = 0 Then                                             '  ,    -  SIM900D 
'       

Else                                                        '   1,    -  

  Wait 2
    If Vkl = 1 Then                                         '        1 
     Goto Pwrmodule
    Else
    End If
End If

Flushbuf

Waitms 10
Return



'  
'========================================================================================
Sensor:

If Pir = 0 Then                                             '    -    

Pirsms = 0

Call D3310position(0 , 4)
Call D3310print( "              ")

Call D3310position(0 , 4)
Call D3310print( ": 0       ")
Pirstr = "0"

  Wait 1

   If Pirsend = 0 Then                                      '  
    Otvet = "Alarm!"
    Gosub Sendsms                                           '     
    Pirsend = 1                                             '   
   End If

Else

Call D3310position(0 , 4)
Call D3310print( ": 1       ")
Pirstr = "1"

Pirsms = 1


End If

 If Pirsend = 0 Then
     Call D3310position(13 , 4)
     Call D3310print( " ")
     Pirsendstr = "Yes"
   Else
     Call D3310position(13 , 4)
     Call D3310print( "!")                                  '        
     Pirsendstr = "No"
  End If

Flushbuf
Waitms 10

Return


'     
'     ,      
'==========================================================================================
Readfirstsms:


  Print "AT+CMGR=1"                                         '   
  Waitms 10
  Getline Sk
  Waitms 10
  Getline Sk
  Number = Mid(sk , 22 , 12)                                '     
  Sms = Sk                                                  '   
  Sms = Left(sms , 4)

   If Sms = "+CMG" Then

    Waitms 10
    Getline Sk                                              ',    
    Sms = Sk
    Sms = Left(sms , 14)                                    '   14    ( -   )

            Do
              Led = 0
              Waitms 100
              Led = 1
              Waitms 50
              Incr F
            Loop Until F = 10                               '   
            F = 0


  Print "AT+CMGDA=" ; Chr(34) ; "DEL ALL" ; Chr(34)         '  

 End If

  Waitms 100
  Flushbuf                                                  ' 

Return





'  
Ok:

If Pirsend = 1 Then
  Pirsend = 0                                               '      

     Call D3310position(13 , 4)
     Call D3310print( " ")

Else
  Pirsend = 1                                               '     
  Call D3310position(13 , 4)
  Call D3310print( "!")                                     '        


End If

Pirsendeep = Pirsend                                        '   

Waitms 250
Gifr = 32

Return